/*
   Use the assembly language listing from this file
   as a way to experiment with arbitrary assembly code.

   Compile this file with

   gcc -Og -S -o main_for_assembly_code.s  main_for_assembly_code.c

   to generate the main_for_assembly_code.s file.
   Open that assembly listing in an editor and add your
   own assembly instructions into that file. Then use

   gcc -Og    -o main_for_assembly_code.exe  main_for_assembly_code.s

   to assemble the assembly listing into an exe file.
   Load the exe file into a debugger and use the debugger
   to watch what your assembly code does.

   > gdb main_for_assembly_code.exe
   <gdb> b main
   <gdb> run
   <gdb> disas main
   <gdb> stepi
   <gdb> print /x $rax
   <gdb> print /x $rdx
   <gdb> contiue
   <gdb> q

*/
#include <stdio.h>

int y = 1234;  // global variable

int main()
{
    int x = 5678;  // local variable

    // Put assembly language instructions in the assembly listing.
    // The two printf's below will show your results.

    printf("y = %d\n", y);
    printf("x = %d\n", x);

    return 0;
}
